package p_PointsIQ;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import p_OP_engine.DrawSingleGameEngine;
import p_OP_engine.SingleGameEngine;
import p_OP_engine.SingleGameEngineInterface.MoveType;
import p_PointsIQ.Question.Makros.MakrosLevelMove;

public class PointsIQ extends JFrame implements Variables,Runnable,MouseMotionListener,MouseListener,WindowListener{

	int preX=0,preY=0;
	JButton butText,butNext,butSGF,butRePlay;
	C_AddComponent add=new C_AddComponent(this.getContentPane());
	QuestionIO base;
	Question question;
	int curQuestion=0;
	int curLevel=0;String preLevels="";Point AIAnswer=null;
	JLabel label=new JLabel();
	protected JLabel labelCoordinates=new JLabel();
	public Thread t=new Thread(this);
	public SingleGameEngine singleGameEngine;
	public DrawSingleGameEngine OP_paint=new DrawSingleGameEngine();
	private Graphics graphics;
	int qNumber=0,qLevel=0,qTrue=0,qThis=0;
	boolean isComplete=true,isRePlay=false;
	{		
		butText=(JButton)add.component("button", 10, 370, 330, 125, "", null);
		butText.setEnabled(false);butText.setForeground(Color.black);butText.setBackground(Color.white);
		labelCoordinates.setBounds(10, 5, 70, 20);this.add(labelCoordinates);
		label.setBounds(70, 5, 270, 17);this.add(label);
		
		butNext=(JButton) add.component("button", 10, 500, 95, 25, "<html>", new ActionListener() {
			public void actionPerformed(ActionEvent e) {nextTask();}
		});	
		butRePlay=(JButton) add.component("button", 115, 500, 95, 25, "<html>", new ActionListener() {
			public void actionPerformed(ActionEvent e) {preTask();}
		});	
		butSGF=(JButton) add.component("button", 220, 500, 120, 25, "<html>  .sgf", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String content ="(;FF[4]GM[40]CA[UTF-8]AP[PointsIQ]SZ[20]RU[Punish=0,Holes=1,AddTurn=0,MustSurr=1,MinArea=1,Pass=0,Stop=0,LastSafe=0,ScoreTerr=0,InstantWin=0]PB[blue]PW[red]";
				String str="";
				try{str=question.startPos;}catch(Exception exc){}
				String move;
				MoveType moveType;
				while(str.length()>1){
					move=str.substring(str.indexOf("[")+1,str.indexOf("]"));
					str=str.substring(str.indexOf("]")+1);
					int x=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
					int y=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
					if(move.equals("R")){moveType=MoveType.RED;}else {moveType=MoveType.BLUE;}
					content += ";" + ((moveType == MoveType.RED) ? "W" : "B");
					content += "[" + getSgfCoord(x) + "" + getSgfCoord(20 + 1 - y) + "]";
				}
				content += ")";
				try {
					new C_SaveFile(PointsIQ.this,content,"PointsIQ",".sgf");
				} catch (Exception exc) {}
			}
		});	
	}
	
public PointsIQ(int level){
	new C_JFrame(this,appName,false,350,530,new Color(255,255,255));
	this.addMouseListener(this);
	this.addWindowListener(this);
	this.addMouseMotionListener(this);
	
	base=new QuestionIO(level);
	for(int i=0;i<base.base.length;i++){if(base.base[i].level==level)qNumber++;}
	if(qNumber==0){new JOptionPane().showMessageDialog(null, "    !");System.exit(-1);}
	qLevel=level;setLabelText(getLabelText());
	this.setTitle(this.getTitle()+"  "+level);
	t=new Thread(PointsIQ.this);t.start();
	
	nextTask();
}
	
private void nextTask(){
	butNext.setEnabled(false);butRePlay.setEnabled(false);
	curLevel=0;preLevels="";AIAnswer=null;isRePlay=false;
	
	for(int i=curQuestion;i<=base.base.length;i++){
		if(i==base.base.length){
			new JOptionPane().showMessageDialog(null,"<html> .<br>  "+qTrue+"  "+qThis);
			System.exit(-1);
			break;
		}
		if(base.base[i].level==qLevel){
			curQuestion=i+1;question=base.getQuestion(base.base[i].index);
			newGame();isComplete=false;showQuestion();t=new Thread(PointsIQ.this);t.start();break;
		}
	}
}

private void preTask(){
	butNext.setEnabled(false);butRePlay.setEnabled(false);
	curLevel=0;preLevels="";AIAnswer=null;isRePlay=true;
	
	question=base.getQuestion(base.base[curQuestion-1].index);
	newGame();isComplete=false;showQuestion();t=new Thread(PointsIQ.this);t.start();
}

public void mousePressed(MouseEvent me) {
	int x=getMouseClickX(me);
	int y=getMouseClickY(me);
		
	if(!isComplete){
		if(isCanMakeMove(x,y)){
			OP_paint.setLastHuman(x,y);OP_paint.setLastAI(-1,-1);makeMove(x,y, MoveType.BLUE);
			if(isExistsLevelMove(x,y)){
				if(isCanMakeMove(AIAnswer.x,AIAnswer.y)){OP_paint.setLastHuman(-1, -1);OP_paint.setLastAI(AIAnswer.x,AIAnswer.y);makeMove(AIAnswer.x,AIAnswer.y, MoveType.RED);}
				else {
					isComplete=true;
					if(!isRePlay){qTrue++;qThis++;}
					setLabelText(getLabelText());
					butText.setText("<html><font color=green>  !");
					butNext.setEnabled(true);
					t=new Thread(PointsIQ.this);t.start();
				}
			}
		}
	}
}

public boolean isExistsLevelMove(int x,int y){
	MakrosLevelMove moves[]=question.makros.getMoves();
	for(int i=0;i<moves.length;i++){
		if(moves[i].levelNumber==(curLevel+1)){
			if((moves[i].humanPoint.x)==x&(moves[i].humanPoint.y)==y&preLevels.equals(moves[i].preLevels)){
				AIAnswer=new Point(moves[i].AIPoint.x,moves[i].AIPoint.y);
				preLevels=moves[i].preLevels+moves[i].levelLetter;
				curLevel++;return true;
			}
		}
	}
	isComplete=true;
	if(!isRePlay){qThis++;}
	setLabelText(getLabelText());
	butText.setText("<html><font color=red>  !<br><font color=black>   :<br>"+question.comment);
	butNext.setEnabled(true);
	butRePlay.setEnabled(true);
	t=new Thread(PointsIQ.this);t.start();
	return false;
}

public void windowActivated(WindowEvent e) {t.stop();t=new Thread(this);t.start();}
	
public static void main(String[] args){
	int l=0;
	try{l=new Integer(new JOptionPane().showInputDialog(null, "    1  4"));}
	catch(Exception e){new JOptionPane().showMessageDialog(null, "  !");System.exit(-1);}
	new PointsIQ(l);
}

public void showQuestion(){
	qLevel=question.level;
	butText.setText("<html> :<br>"+question.text);
	showStartPos(question.startPos);
	setLabelText(getLabelText());	
	repaint();
}

public void showStartPos(String str){
	String move;
	while(str.length()>1){
		move=str.substring(str.indexOf("[")+1,str.indexOf("]"));
		str=str.substring(str.indexOf("]")+1);
		int x=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
		int y=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
		if(move.equals("R")){OP_paint.setLastHuman(-1, -1);OP_paint.setLastAI(x, y);singleGameEngine.makeMove(x,y, MoveType.RED);}
		else {OP_paint.setLastAI(-1, -1);OP_paint.setLastHuman(x, y);singleGameEngine.makeMove(x,y, MoveType.BLUE);}
	}
}

public void run(){try{try{t.sleep(200);}catch(Exception e){}repaint();t.stop();}catch(Exception e){}}
void makeMove(int x, int y,MoveType moveType){singleGameEngine.makeMove(x,y,moveType);setLabelText(getLabelText());repaint();}
void newGame(){setLabelText(getLabelText());singleGameEngine=new SingleGameEngine(sizeX,sizeY);}	

public void mouseMoved(MouseEvent me){try{
	if(getMouseClickX(me)!=preX|getMouseClickY(me)!=preY){
		Graphics graphics=this.getGraphics();
		if(isCanMakeMove(preX, preY)){
			graphics.setColor(Color.white);
			graphics.drawOval(preX*squareSize+9, preY*squareSize+41, 6, 6);
			graphics.setColor(new Color(225,225,225));
			graphics.drawLine(preX*squareSize+9, preY*squareSize+44, preX*squareSize+15, preY*squareSize+44);
			graphics.drawLine(preX*squareSize+12, preY*squareSize+41, preX*squareSize+12, preY*squareSize+47);
		}		
		preX=getMouseClickX(me);preY=getMouseClickY(me);	
		if(preX>0&preX<(sizeX+1)&preY>0&preY<(sizeY+1))labelCoordinates.setText("<HTML><font color=gray>"+preX+":"+preY);
		if(isCanMakeMove(preX, preY)){
			graphics.setColor(Color.blue);
			graphics.drawOval(preX*squareSize+9, preY*squareSize+41, 6, 6);
		}
	}
}catch(Exception e){}}

private String getSgfCoord(int i){if (i <= 26) {return Character.toString((char) ((int) 'a' + i - 1));}else {return Character.toString((char) ((int) 'A' + i - 26 - 1));}}
boolean isCanMakeMove(int x, int y){return singleGameEngine.canMakeMove(x,y);}
int getMouseClickX(MouseEvent me){return (int)(((double)me.getX()-5-(double)((offsetX-1)*squareSize))/(double)squareSize);};
int getMouseClickY(MouseEvent me){return (int)(((double)me.getY()-5-(double)((offsetY-1)*squareSize))/(double)squareSize);};
public void repaint(){
	graphics=getGraphics();
	graphics.setColor(new Color(254,254,254));
	graphics.fillRect(0, 50, squareSize*(sizeX+1+offsetX), sizeY*(squareSize+1));
	OP_paint.paint(graphics, singleGameEngine);
}
String getLabelText(){return "<HTML>"+spc+" <FONT color=blue>"+qNumber+"</FONT>"+spc+" "+"<FONT color=blue> "+qTrue+"  "+qThis+"</FONT></HTML>";}
public void setLabelText(String text){label.setText(text);}	
public void windowClosed(WindowEvent e) {}
public void windowClosing(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}
public void mouseClicked(MouseEvent me) {}
public void mouseEntered(MouseEvent me) {}
public void mouseExited(MouseEvent me) {}
public void mouseReleased(MouseEvent me) {}
public void mouseDragged(MouseEvent arg0) {}

}